routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::delete('/carts/empty', 'CartController@empty')->name('carts.empty');

Route::put('/transactions/update_ps', 'TransactionController@update_ps')->name('transactions.update_ps');

Route::resource('products', 'ProductController');
Route::resource('locations', 'LocationController');
Route::resource('carts', 'CartController');
Route::resource('transactions', 'TransactionController');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    public function size() {
    	return $this->belongsTo('App\Size');
    }

    public function location() {
    	return $this->belongsTo('App\Location');
    }

    public function basic_lockers() {
    	return $this->belongsToMany('App\Basic_locker','basic_locker')
    	->withPivot('unique_code');
    }

    
    
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Product;
use App\Size;
use App\Location;
use App\Basic_locker;
use Illuminate\Http\Request;
use Str;
use Auth;
use Session;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Product $product)
    {
        $sizes = Size::all();
        $locations = Location::all();
        $products = Product::all();
        $lockers = Basic_locker::all();
        

        return view('products.index')
        ->with('sizes',$sizes)
            ->with('locations',$locations)
            ->with('products',$products)
            ->with('lockers',$lockers);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Product $product)
    {
        $this->authorize('create', $product);

        $sizes = Size::all();
        $locations = Location::all();
        return view('products.create')
            ->with('sizes',$sizes)
            ->with('locations',$locations);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, Product $product)
    {
        $this->authorize('create', $product);
        $request->validate([
                    'name' => 'required|string',
                    'price' => 'required|numeric',
                    'location-id' => 'required',
                    'size-id' => 'required',
                    'description' => 'required|string',
                    'image' => 'required|image|max:5000'
                    ]);

        $product = new Product;

        

        $product->name = $request->input('name');
        $product->price = $request->input('price');
        $product->size_id = $request->input('size-id');
        $product->location_id = $request->input('location-id');
        $product->description = $request->input('description');

        //get acronym of size
        $words = explode(" ", $product->size->name);
         $acronym = "";
         foreach ($words as $w) {
           $acronym .= $w[0];
         }
         


        $product->product_model = $acronym.'-'.$product->size_id.'-'.Str::random(5).'-00'.$product->location_id;

        $product->image = $request->image->store('public');
        $product->save();

        return redirect( route('products.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        return view('products.show')->with('product', $product);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        $this->authorize('create', $product);
        $sizes = Size::all();
        $locations = Location::all();
        return view('products.edit')
            ->with('sizes',$sizes)
            ->with('locations',$locations)
            ->with('product', $product);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {
        $this->authorize('create', $product);
        $request->validate([
                    'name' => 'required|string',
                    'price' => 'required|numeric',
                    'location-id' => 'required',
                    'size-id' => 'required',
                    'description' => 'required|string',
                    'image' => 'image|max:5000'
                    ]);

        $product->name = $request->input('name');
        $product->price = $request->input('price');
        $product->size_id = $request->input('size-id');
        $product->location_id = $request->input('location-id');
        $product->description = $request->input('description');
        

        if($request->hasFile('image')) {
          $product->image = $request->image->store('public');
        } 

        

        
        $product->save();

        $request->session()->flash('status','Update to locker details successful!');

        return redirect( route('products.edit',['product'=>$product->id]));


    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $this->authorize('create', $product);
        $product->delete();
        return redirect( route('products.index'))->with('status','Locker is deleted. Go to Add Locker to add another locker product.');
    }
}

resources/views/products/create.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
		<div class="row">
			<div class="col-12 col-md-8 mx-auto">
				<div class="card lockeroo">
					<div class="card-header">
				<h4>Create Locker Sheet</h4>
				</div>
				
				<div class="card-body watermarked">
				<form class="form-group" action="{{ route('products.store')}}" method="POST" enctype="multipart/form-data">
					@csrf

					{{-- @if($errors->has('name'))
						<div class="alert alert-danger">
							{{$errors->first('name')}}
						</div>
					@endif --}}

					
					<!-- locker name -->
					<div class="form-group row">

						<label for="name" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="https://1.bp.blogspot.com/-ALf_hY4lWUU/Xh3Cy-ZyyGI/AAAAAAAALz4/8gt9ImeHRgYrycTFT_Gus_Wh98CfiyJ-ACLcBGAsYHQ/s1600/icons8-safe-64.png" alt="">
       <!-- {{ __('Name') }} -->
      </label>
					
					<div class="col-md-9">
					<input type="text" name="name" id="name" class="form-control mb-2 @error('name') is-invalid @enderror" placeholder="Locker Name" value="{{ old('name')}}">

					@error('name')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror

					</div>
					
					
				</div>


					
					<!-- locker price -->
					<div class="form-group row">

						<label for="price" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="http://4.bp.blogspot.com/-cu1R8d4-Zas/Xh3E5A8I_vI/AAAAAAAAL0o/GD-37mLgnH4a7Aa-APw6S7Nn0rTQDvX6wCK4BGAYYCw/s400/icons8-us-dollar-64.png" alt="">
       <!-- {{ __('Name') }} -->
      </label>
					
					<div class="col-md-9">
					<input type="text" name="price" id="price" class="form-control mb-2 @error('price') is-invalid @enderror" placeholder="Locker Rental Price per Day" value="{{ old('price')}}">

					@error('price')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror
				</div>
			</div>

			<!-- locker location -->
						<div class="form-group row">

						<label for="location-id" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="http://4.bp.blogspot.com/-4MfDLOiAssY/Xh3DZLngjAI/AAAAAAAAL0U/FX8puGiPctY8DQ8eV6SbjZ6BISpWHII7gCK4BGAYYCw/s400/icons8-location-64.png" alt="">
       <!-- {{ __('Name') }} -->
      </label>
					
					<div class="col-md-9">
					<select name="location-id" id="location-id" class="custom-select">
						@foreach($locations as $location)
							<option 
								value="{{$location->id}}"
								{{ old('size-id') == $location->id ? "selected" : ""}}
								>
								{{$location->name}}
							</option>
						@endforeach	
					</select>
				</div>
			</div>
					
					<!-- @if($errors->has('image'))
						<div class="alert alert-danger">
							{{$errors->first('image')}}
						</div>
					@endif -->
					
					<!-- locker size -->
						<div class="form-group row">

						<label for="size-id" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="https://1.bp.blogspot.com/-Na9k-xcN1mg/Xh3Cyu6NSFI/AAAAAAAALz0/WliDCNbK7awS85AH1ER--UyDqeCJl3MggCLcBGAsYHQ/s1600/icons8-open-box-64.png" alt="">
       <!-- {{ __('Name') }} -->
      </label>
					
					<div class="col-md-9">
					<select name="size-id" id="size-id" class="custom-select">
						@foreach($sizes as $size)
							<option 
								value="{{$size->id}}"
								{{ old('size-id') == $size->id ? "selected" : ""}}
								>
								{{$size->name}}
							</option>
						@endforeach	
					</select>
				</div>
			</div>
					
					<!-- @if($errors->has('image'))
						<div class="alert alert-danger">
							{{$errors->first('image')}}
						</div>
					@endif -->
					
					<!-- locker image -->
					<div class="form-group row">

						<label for="image" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="http://4.bp.blogspot.com/-ZZoTgQcCz-o/Xh3E5DYoQQI/AAAAAAAAL0s/ZkwnPFriJM8dnWKl0E1yUfSoUcVSDo8igCK4BGAYYCw/s400/icons8-photo-gallery-64.png" alt="">
       <!-- {{ __('Name') }} -->
      </label>
					
					<div class="col-md-9">
					<input type="file" name="image" id="image" class="form-control-file mb-2 @error('image') is-invalid @enderror">
					@error('image')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror
					</div>
				</div>

					
					<!-- @if($errors->has('description'))
						<div class="alert alert-danger">
							{{$errors->first('description')}}
						</div>
					@endif -->
					
					<!-- locker description -->
					<div class="form-group row">

						<label for="description" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="https://1.bp.blogspot.com/-lt_jfQcesik/Xh3CxgNtB5I/AAAAAAAALzs/RuL1GGe2rmQQi2pEVQiBFZQBwwO8EaN4QCLcBGAsYHQ/s1600/icons8-news-256.png" alt="">
       <!-- {{ __('Name') }} -->
      </label>
					
					<div class="col-md-9">
					<textarea name="description" id="description" cols="10" rows="10" class="form-control mb-2 @error('description') is-invalid @enderror" placeholder="Locker Description">{{ old('description')}}</textarea>

					@error('description')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror
				</div>
			</div>

					<div class="form-group row text-left"><button type="submit" class="btn btn-lockred mb-2 mx-auto">Create New Locker</button>
						</div>
				</form>
				</div>
			</div>
		</div>
	</div>
	</div>

@endsection

resources/views/products/edit.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
		<div class="row">

			<div class="col-12 col-md-4 mx-auto">
				@include('products.includes.products')

			</div>
			<div class="col-12 col-md-8 mx-auto">
				<div class="card lockeroo">
					<div class="card-header">
				<h4>Edit Locker Sheet
					@if(Session::has('status')) 
						
							<sup>
							<span class="badge badge-success">
							{{Session::get('status')}}
							</sup>
						</span>
						
				</h4>


					@endif
				</div>
				
				<div class="card-body watermarked">
				<form class="form-group" action="{{ route('products.update', ['product'=> $product->id])}}" method="POST" enctype="multipart/form-data">
					@csrf
					@method('PUT')

					{{-- @if($errors->has('name'))
						<div class="alert alert-danger">
							{{$errors->first('name')}}
						</div>
					@endif --}}

					
					<!-- locker name -->
					<div class="form-group row">

						<label for="name" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="https://1.bp.blogspot.com/-ALf_hY4lWUU/Xh3Cy-ZyyGI/AAAAAAAALz4/8gt9ImeHRgYrycTFT_Gus_Wh98CfiyJ-ACLcBGAsYHQ/s1600/icons8-safe-64.png" alt="">
       
      </label>
					
					<div class="col-md-9">
					<input type="text" name="name" id="name" class="form-control mb-2 @error('name') is-invalid @enderror" placeholder="Locker Name" value="{{ $product->name}}">

					@error('name')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror

					</div>
					
					
				</div>


					
					<!-- locker price -->
					<div class="form-group row">

						<label for="price" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="http://4.bp.blogspot.com/-cu1R8d4-Zas/Xh3E5A8I_vI/AAAAAAAAL0o/GD-37mLgnH4a7Aa-APw6S7Nn0rTQDvX6wCK4BGAYYCw/s400/icons8-us-dollar-64.png" alt="">
       
      </label>
					
					<div class="col-md-9">
					<input type="text" name="price" id="price" class="form-control mb-2 @error('price') is-invalid @enderror" placeholder="Locker Rental Price per Day" value="{{ $product->price}}">

					@error('price')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror
				</div>
			</div>

			<!-- locker location -->
						<div class="form-group row">

						<label for="location-id" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="http://4.bp.blogspot.com/-4MfDLOiAssY/Xh3DZLngjAI/AAAAAAAAL0U/FX8puGiPctY8DQ8eV6SbjZ6BISpWHII7gCK4BGAYYCw/s400/icons8-location-64.png" alt="">
       
      </label>
					
					<div class="col-md-9">
					<select name="location-id" id="location-id" class="custom-select">
						@foreach($locations as $location)
							<option 
								value="{{$location->id}}"
								{{ $product->location_id == $location->id ? "selected" : ""}}
								>
								{{$location->name}}
							</option>
						@endforeach	
					</select>
				</div>
			</div>
					
				{{-- 	@if($errors->has('image'))
						<div class="alert alert-danger">
							{{$errors->first('image')}}
						</div>
					@endif --}}
					
					<!-- locker size -->
						<div class="form-group row">

						<label for="size-id" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="https://1.bp.blogspot.com/-Na9k-xcN1mg/Xh3Cyu6NSFI/AAAAAAAALz0/WliDCNbK7awS85AH1ER--UyDqeCJl3MggCLcBGAsYHQ/s1600/icons8-open-box-64.png" alt="">
       
      </label>
					
					<div class="col-md-9">
					<select name="size-id" id="size-id" class="custom-select">
						@foreach($sizes as $size)
							<option 
								value="{{$size->id}}"
								{{ $product->size_id == $size->id ? "selected" : ""}}
								>
								{{$size->name}}
							</option>
						@endforeach	
					</select>
				</div>
			</div>
					
					{{-- @if($errors->has('image'))
						<div class="alert alert-danger">
							{{$errors->first('image')}}
						</div>
					@endif --}}
					
					<!-- locker image -->
					<div class="form-group row">

						<label for="image" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="http://4.bp.blogspot.com/-ZZoTgQcCz-o/Xh3E5DYoQQI/AAAAAAAAL0s/ZkwnPFriJM8dnWKl0E1yUfSoUcVSDo8igCK4BGAYYCw/s400/icons8-photo-gallery-64.png" alt="">
       
      </label>
					
					<div class="col-md-9">
					<input type="file" name="image" id="image" class="form-control-file mb-2">
					
					</div>
				</div>

					
					{{-- @if($errors->has('description'))
						<div class="alert alert-danger">
							{{$errors->first('description')}}
						</div>
					@endif --}}
					
					<!-- locker description -->
					<div class="form-group row">

						<label for="description" class="col-md-2 col-form-label text-md-right">
       <img class="reg-icon" src="https://1.bp.blogspot.com/-lt_jfQcesik/Xh3CxgNtB5I/AAAAAAAALzs/RuL1GGe2rmQQi2pEVQiBFZQBwwO8EaN4QCLcBGAsYHQ/s1600/icons8-news-256.png" alt="">
       
      </label>
					
					<div class="col-md-9">
					<textarea name="description" id="description" cols="10" rows="10" class="form-control mb-2 @error('description') is-invalid @enderror" placeholder="Locker Description">{{ $product->description}}</textarea>

					@error('description')
       <span class="invalid-feedback" role="alert">
           <strong>{{ $message }}</strong>
       </span>
   @enderror
				</div>
			</div>

					<div class="form-group row text-left"><button type="submit" class="btn btn-lockred mb-2 mx-auto">Update Locker Details</button>
						</div>
				</form>
				</div>
			</div>
		</div>
	</div>
	</div>

	
							
@endsection

resources/views/products/index.blade.php
@extends('layouts.app')

@section('content')


{{-- TABLE ADMIN VIEW --}}
@can('isAdmin')
<div class="container">
	<div class="row">
		<div class="col-12 col-md-10 offset-md-1 card-header lockeroo">
			<h1>Available Stocks</h1>
		</div>
		<div class="table-responsive col-12 col-md-10 offset-md-1">
		{{-- product_transaction table start --}}
				<table class="table table-striped table-hover">
					<thead class="card-header lockeroo">
						<th scope="row">Item Code</th>
						{{-- <th scope="row">Model</th>
						<th scope="row">Size</th>
						<th scope="row">Location</th> --}}
						<th scope="row">Status</th>
					</thead>

					<tbody class="card-body">
						{{-- product_transaction details start --}}
							
						@foreach($lockers as $locker)
							<tr>
								<td>
									{{$locker->unique_code}}
								</td>
								{{-- <td>
									{{$locker->products->name}}
								</td>
								<td>
									{{$products->size->name}}
								</td>
								<td>
									{{$product->location->name}}
								</td> --}}
								<td>
									{{$locker->product_status->name}}
								</td>
							</tr>

							@endforeach
						{{-- product_transaction details start --}}


					</tbody>
					<tfoot>
						

					</tfoot>
				</table>

				{{-- product_transaction table start --}}
		
	</div>
	</div>
</div>
@endcan


{{-- PRODUCTS VIEW --}}

<div class="container">
	<div class="row">
		<div class="col-12">
			<form action="" method="get">
				
				{{-- <div class="row">
					<div class="col">
						<select name="category" id="category" class="form-control">
							<option value="">All</option>
							@foreach($sizes as $size)
							<option value="{{$size->id}}">{{$size->name}}</option>
							@endforeach
						</select>
					</div>
					<div class="col">
				<button class="btn btn-outline-primary">
					Filter
				</button>
						
					</div>
				</div> --}}
				
			</form>
		</div>
	</div>
	@if(Session::has('status'))
		<div class="badge badge-danger mb-3 mx-auto text-center">
			{{Session::get('status')}}
		</div>

	@endif

	{{-- @include('products.includes.error-status') --}}
	<div class="row">


	@foreach($products as $product)
		{{-- START OF CARDS --}}
		<div class="col-12 col-md-4 col-lg-3 pb-3">
			@include('products.includes.products')
		</div>
		{{-- END OF CARD --}}
	@endforeach
	</div>
</div>

@endsection

resources/views/products/show.blade.php
@extends('layouts.app')

@section('content')

<div class="col-12 px-3 text-right card-body"><h6 class="btn btn-lockwhite"><a href="{{ route('products.index')}}">Back to Products</a></h6>
	</div>

{{-- @include('products.includes.error-status') --}}

{{-- START OF CARDS --}}

	<div class="container">
		<div class="row">
			

			<div class="col-12 col-md-6 pb-3">
			<div class="card">
				<img src="/public/{{$product->image}}" alt="" class="card-img-top">
				
				
			</div>
		</div>

		<div class="col-12 col-md-6">
			<div class="card-body">
					<div class="card-header lockeroo">
					<h5 class="">{{$product->name}}</h5>
					</div>
					<p class="card-text">&#8369;{{number_format($product->price,2)}}</p>
					<p class="card-text"><small class="badge badge-primary">{{$product->size->name}}</small></p>
					<p class="card-text">{{$product->description}}</p>
				</div>
			<div class="card-footer">
					{{-- @cannot('isAdmin') --}}
					<form action="{{ route('carts.update',['cart' => $product->id]) }}" method="POST">
						@csrf
						@method('PUT')
						
						<input type="number" name="duration" id="duration" class="form-control mb-2" min="1">
						
						<button class="btn btn-lockblue w-100 mb-2">Add to Cart</button>
						
					</form>
					{{-- @endcannot --}}
					<a href="{{ route('products.show', ['product'=> $product->id])}}" class="btn btn-lockwhite w-100 mb-2">View Locker</a>
					
					{{-- @can('isAdmin') --}}
					<a href="/products/{{$product->id}}/edit" class="btn btn-lockblue w-100 mb-2">Edit Locker</a>
					<form action="{{ route('products.destroy', ['product'=>$product->id])}}" method="POST">
						@csrf
						@method('DELETE')
						<button class="btn btn-lockred w-100 mb-2">Delete Locker</button>
					</form>
					{{-- @endcan --}}
				</div>
		</div>

		</div>
	</div>
		
		{{-- END OF CARD --}}



@endsection